<?php

class Mo_wpns_Scan_Handler_Cron{
	private $total_files_to_scan;
	public $scanned_files = array();
	function __construct(){

	}

	function mo2f_scan_all_files($scan_config, $start_time){
		ini_set('memory_limit', '-1');
		// ini_set('max_execution_time', 0);
		$time_limit= ini_get('max_execution_time');

		$result = array();
		$folderpaths = array();
		$wp_repo_file = array();
		$folderNames = "";
		$repo_check_status_code=0;
		update_option('mo_stop_scan','0');
		$base = dirname(dirname(dirname(dirname(dirname(plugin_dir_path(__FILE__))))));
		$hostname = 'wordpress.org';
		$wordpress_server_status = $this->mo_wpns_check_malware_server_status($hostname); //check only if writable
		$uploads_dir = wp_upload_dir();
		$uploads_path= $uploads_dir['basedir'];
		if (!is_writable($uploads_path)) { //
			$scan_config['check_repo'] = 0;
			$repo_check_status_code = -97;
		}
		if (!$wordpress_server_status && $repo_check_status_code == 0) {
			$scan_config['check_repo'] = 0;
			$repo_check_status_code = -98;
		}
		if($scan_config['core_scan'] == 1){
			$folderpaths['base'] = $base;
			$folderNames .= "WP Files;";
		} 		
		if($scan_config['plugin_scan'] == 1){
			$folderpaths['plugins'] = $base.DIRECTORY_SEPARATOR."wp-content".DIRECTORY_SEPARATOR."plugins";
			$folderNames .= "Plugins;";
		}
		if($scan_config['theme_scan'] == 1){
			$folderpaths['themes'] = $base.DIRECTORY_SEPARATOR."wp-content".DIRECTORY_SEPARATOR."themes";
			$folderNames .= "Themes;";
		}
		if($scan_config['check_repo'] == 1){
			$folderNames .= "WP Repo Files;";
		}

		$this->count_total_files($folderpaths, $base, $scan_config);

		update_option('mo2f_repo_status', $repo_check_status_code);

		$mo2f_malware_db_handler = new MoWpnsDB();
		$reportid = $mo2f_malware_db_handler->create_scan_report($folderNames, $scan_config['type_scan'], $start_time);
		update_option('mo2f_report_id', $reportid);

		$scan_handler_obj = new mo2f_scanner_parts;

		//wp remote get
		$scanverification=$this->createKeyCurrentScan($scan_config['type_scan'],$reportid);

		$response=$this->mo2f_wp_remote_get($scan_config['type_scan'], $reportid, $scanverification, 1);

		wp_send_json('success');
	}

	function createKeyCurrentScan($scan_mode,$reportid){

		$scanverification=md5($scan_mode. MO2f_Utility::random_str(24).$reportid);
		update_option("mo2f_scanverification",$scanverification);
		return $scanverification;
	}

	function mo2f_wp_remote_get($scan_mode, $reportid, $scanverification,$scan_stage_complete=1){
		//set time out based on time left or 10 secs

		$http_header_array =array("Content-Type"=>"application/json","charset"=>"UTF-8","Authorization"=>"Basic");
		$url = get_site_url()."?scan_request=1"."&scanverification=".$scanverification."&reportid=".$reportid."&scan_stage_complete=".$scan_stage_complete."&scan_mode=".$scan_mode;//scanverification,report_id, scan_stage_complete and scan_mode

		$args = array(
			'method' => 'GET',
			'body' => '',
			'timeout' => '5',
			'redirection' => '5',
			'httpversion' => '1.0',
			'blocking' => true,
			'headers' => $http_header_array
		);
		$response= wp_remote_get($url,$args);
		//$response->errors['http_request_failed']['0'];

	}

	function mo2f_download_core_wp($repo_file_path, $scan_config, $reportid, $scanverification, $scan_mode){
		error_log("downloading core");
		$repo_check_status = $scan_config['check_repo'];
		$repo_check_status_code=get_option('mo2f_repo_status');
		$wp_repo_file=get_option('mo2f_repo_path');
		if ( ! function_exists( 'get_plugins' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}
		if ( ! function_exists( 'plugins_api' ) ) {
		    require_once( ABSPATH . 'wp-admin/includes/plugin-install.php' );
		}
		
		if($scan_config['core_scan'] == 1 && $scan_config['check_repo'] && ($repo_check_status_code == 0)){
			if(!is_dir($repo_file_path)){
				mkdir($repo_file_path);
			}
			$download_status=array("download_state" => "wordpress_download_initiated", "time" => time());
			update_option('wordpress_download_status', $download_status);
            require(ABSPATH . 'wp-includes/version.php');
			//wordpress name to be changed to be changed based on version
			$zip_name="wp-".$wp_version;
			$wp_repo_file['base']=$repo_file_path.DIRECTORY_SEPARATOR.$zip_name;
			update_option('downloaded_wordpress_repo_name', $zip_name);
			if(!is_dir($repo_file_path.DIRECTORY_SEPARATOR.$zip_name)){
				$result = $this->download_repo($zip_name, $wp_version, $repo_file_path);
				if($result === -99){
					$scan_config['check_repo'] = 0;
					$repo_check_status_code = -99;
				}else if(!$result){
					$scan_config['check_repo'] = 0;
					$repo_check_status_code = -100;
				}
			}
		}

		if($repo_check_status != $scan_config['check_repo']){
			update_option('mo2f_repo_issue',true);
			update_option('mo2f_repo_status', $repo_check_status_code);
			$scan_stage_complete=6;
		}else{
			update_option('mo2f_repo_path', $wp_repo_file);
			$scan_stage_complete=6;
		}

		$Mo_wpns_Scan_Handler_Cron = new Mo_wpns_Scan_Handler_Cron();
		$response=$Mo_wpns_Scan_Handler_Cron->mo2f_wp_remote_get($scan_config['type_scan'], $reportid, $scanverification, $scan_stage_complete);
		
	}

	function mo2f_download_plugins_wp($repo_file_path, $scan_config, $start_time, $time_limit, $reportid, $scanverification,$scan_mode){
		error_log("downloading plugins");
		$repo_check_status = $scan_config['check_repo'];
		$repo_check_status_code=get_option('mo2f_repo_status');
		$flag=0;
		$wp_repo_file=array();
		if ( ! function_exists( 'get_plugins' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}
		if ( ! function_exists( 'plugins_api' ) ) {
		    require_once( ABSPATH . 'wp-admin/includes/plugin-install.php' );
		}
		
		if($scan_config['plugin_scan'] == 1 && $scan_config['check_repo'] && ($repo_check_status_code == 0)){
			if(!is_dir($repo_file_path)){
				mkdir($repo_file_path);
			}
			$wp_plugin_repo_file=$repo_file_path.DIRECTORY_SEPARATOR."plugins";
			if(!is_dir($wp_plugin_repo_file)){
				mkdir($wp_plugin_repo_file);
			}
			
			$wp_repo_file['plugins']=$wp_plugin_repo_file;
			$plugin_list=get_site_transient( 'update_plugins' );
	        $all_plugins=array();
			foreach ($plugin_list as $key => $value) {
				if($key=='response'||$key=='no_update'){
					foreach ($value as $ke => $val) {
						$all_plugins[$ke] = $val;
					}
				}
			}
	        $result = $this->iterator_plugins_themes($all_plugins, $wp_plugin_repo_file, 'plugins', $start_time, $time_limit,$scan_config,$reportid, $scanverification,$scan_mode);
	        if($result === -99){
				$scan_config['check_repo'] = 0;
				$repo_check_status_code = -99;
			}else if(!$result){
				$scan_config['check_repo'] = 0;
				$repo_check_status_code = -100;
			}else if($result === 'incomplete'){
				$flag=1;
			}
		}
		if($repo_check_status != $scan_config['check_repo']){
			update_option('mo2f_repo_issue',true);
			update_option('mo2f_repo_status', $repo_check_status_code);
			$scan_stage_complete=6;
		}else{
			if($flag == 1){
				$scan_stage_complete=3;
			}else{
				update_option('mo2f_repo_path', $wp_repo_file);
				update_option('mo2f_download_done',0);
				$scan_stage_complete=4;
			}
		}
		$Mo_wpns_Scan_Handler_Cron = new Mo_wpns_Scan_Handler_Cron();
		$response=$Mo_wpns_Scan_Handler_Cron->mo2f_wp_remote_get($scan_config['type_scan'], $reportid, $scanverification, $scan_stage_complete);

	}

	function mo2f_download_themes_wp($repo_file_path, $scan_config, $start_time, $time_limit,$reportid, $scanverification,$scan_mode){
		error_log("downloading themes");
		$repo_check_status = $scan_config['check_repo'];
		$repo_check_status_code=get_option('mo2f_repo_status');
		$flag=0;
		$wp_repo_file=get_option('mo2f_repo_path');
		if ( ! function_exists( 'get_plugins' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}
		if ( ! function_exists( 'plugins_api' ) ) {
		    require_once( ABSPATH . 'wp-admin/includes/plugin-install.php' );
		}
		
		if($scan_config['theme_scan'] == 1 && $scan_config['check_repo'] && ($repo_check_status_code == 0)){
			if(!is_dir($repo_file_path)){
				mkdir($repo_file_path);
			}
			$wp_theme_repo_file=$repo_file_path.DIRECTORY_SEPARATOR."themes";
			if(!is_dir($wp_theme_repo_file)){
				mkdir($wp_theme_repo_file);
			}
			
			$wp_repo_file['themes']=$wp_theme_repo_file;
			$all_themes=get_site_transient( 'update_themes' )->checked;
	        $result = $this->iterator_plugins_themes($all_themes, $wp_theme_repo_file, 'themes', $start_time, $time_limit,$scan_config,$reportid,$scanverification,$scan_mode);
	        if($result === -99){
				$scan_config['check_repo'] = 0;
				$repo_check_status_code = -99;
			}else if(!$result){
				$scan_config['check_repo'] = 0;
				$repo_check_status_code = -100;
			}else if($result === 'incomplete'){
				$flag=1;
			}
		}
		if($repo_check_status != $scan_config['check_repo']){
			update_option('mo2f_repo_issue',true);
			update_option('mo2f_repo_status', $repo_check_status_code);
			$scan_stage_complete=6;
		}else{
			if($flag == 1){
				$scan_stage_complete=4;

			}else{
				update_option('mo2f_repo_path', $wp_repo_file);
				update_option('mo2f_download_done',0);
				$scan_stage_complete=5;
			}
		}
		$Mo_wpns_Scan_Handler_Cron = new Mo_wpns_Scan_Handler_Cron();
		$response=$Mo_wpns_Scan_Handler_Cron->mo2f_wp_remote_get($scan_config['type_scan'], $reportid, $scanverification, $scan_stage_complete);
	}

	function iterator_plugins_themes($themes_or_plugins, $path, $type='', $start_time, $time_limit, $scan_config,$reportid, $scanverification,$scan_mode){
		$downloaded_already= get_option('mo2f_download_done');
		if($downloaded_already == false){
			$downloaded_already=0;
		}
		$i=0;
        foreach($themes_or_plugins as $key => $data){
        	$i++;
        	$exec_status= $this->check_exec_limit($start_time, $time_limit);
        	if(! $exec_status){//wp_remote_get
        		update_option('mo2f_download_done', $i-1);
		        $Mo_wpns_Scan_Handler_Cron = new Mo_wpns_Scan_Handler_Cron();
		        if($type=='plugins'){
		        	$scan_stage_complete=4;
		        }else if($type=='themes'){
			        $scan_stage_complete=5;
		        }
		        $response=$Mo_wpns_Scan_Handler_Cron->mo2f_wp_remote_get($scan_config['type_scan'], $reportid, $scanverification, $scan_stage_complete);
        		return 'incomplete';
        	}
        	if($i <= $downloaded_already){
        		continue;
        	}
        	if($type=='plugins'){
	            $plugin_slug=$data->slug;
	            $plugin_directory_location=dirname(dirname(dirname($path))).DIRECTORY_SEPARATOR.'plugins';
	            $plugin_data=get_plugin_data($plugin_directory_location.DIRECTORY_SEPARATOR.$data->plugin);
	            $plugin_version=$plugin_data['Version'];
	            if(!is_dir($path.DIRECTORY_SEPARATOR.$plugin_slug)){
	            	$result= $this->download_repo($plugin_slug, $plugin_version, $path, $type);
	            	if($result === -99){
						return -99;
					}else if(!$result){
	            		return false;
	            	}
	            }
	        } else if($type=='themes'){
	        	if(!is_dir($path.DIRECTORY_SEPARATOR.$key)){
	        		$result= $this->download_repo($key, $data, $path, $type);
	        		if($result === -99){
						return -99;
					}else if(!$result){
	            		return false;
	            	}
	        	}
	        }
        }
        return true;
    }

    function download_repo($zip_name, $version, $path, $type=''){
		if ($type=='plugins') {
			$download_link="https://downloads.wordpress.org/plugin/".$zip_name.".".$version.".zip";
	        $plugin_name=$zip_name.'.'.$version;

	        $download_result=@file_put_contents($path.DIRECTORY_SEPARATOR.$zip_name.".zip", file_get_contents($download_link));
	        if( $download_result){
	            $result = $this->unzip_downloaded_repo($zip_name, $path);
	            return $result;
	        }else {
	        	$download_link="https://downloads.wordpress.org/plugin/".$zip_name.".zip";
	        	$download_result=@file_put_contents($path.DIRECTORY_SEPARATOR.$zip_name.".zip", file_get_contents($download_link));
	        	if( $download_result){
		            $result = $this->unzip_downloaded_repo($zip_name, $path);
		            return $result;
		        }else {
		            error_log("Unable to download Plugin: ".$plugin_name);
		            return -99;
		        }
		        return -99;
	        }
		} else if($type=='themes'){
			$theme_name=$zip_name.'.'.$version;
			$download_link="https://downloads.wordpress.org/theme/".$theme_name.".zip";
	        $download_result=@file_put_contents($path.DIRECTORY_SEPARATOR.$zip_name.".zip", file_get_contents($download_link));
	        if( $download_result){
	            $result = $this->unzip_downloaded_repo($zip_name, $path);
	            return $result;
	        }else {
	        	$download_link="https://downloads.wordpress.org/theme/".$zip_name.".zip";
	        	$download_result=@file_put_contents($path.DIRECTORY_SEPARATOR.$zip_name.".zip", file_get_contents($download_link));
	        	if( $download_result){
		            $result = $this->unzip_downloaded_repo($zip_name, $path);
		            return $result;
		        }else {
		            error_log("Unable to download Theme: ".$theme_name);
		            return -99;
		        }
		        return -99;
	        }
		} else {
			$download_link="https://wordpress.org/wordpress-".$version.".zip";
			$download_result=@file_put_contents($path.DIRECTORY_SEPARATOR.$zip_name.'.zip', file_get_contents($download_link));
			if($download_result){
				$result=$this->unzip_downloaded_repo($zip_name, $path);
				return $result;
			} else {
				error_log("Unable to download wordpress-".$version);
				return -99;
			}
		}
		return false;
	}

	function unzip_downloaded_repo($name, $path){
		$zip = new ZipArchive;
        $folder_path=$path.DIRECTORY_SEPARATOR.$name.".zip";
        $res = $zip->open($folder_path);
        if ($res === TRUE) {
            // extract it to the path we determined above
            $result = $zip->extractTo($path);
            $zip->close();
            if ($name == get_option('downloaded_wordpress_repo_name')) {
            	rename($path.DIRECTORY_SEPARATOR."wordpress", $path.DIRECTORY_SEPARATOR.$name);
            }
            unlink($folder_path);
            return true;
        } else {
            return false;
        }
	}

	function mo_wpns_check_malware_server_status($host){
		$fsock = @fsockopen($host, 80, $errno, $errstr, 5);
        if ( ! $fsock ){
            return FALSE;
        }else{
        	fclose($fsock);
            return TRUE;
        }
	}

	function mo_wpns_malware_scan_request($postdata = array(), $host, $content_type){
		$response = null;
		$ch=curl_init($host);
		curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, false );
		curl_setopt( $ch, CURLOPT_ENCODING, "" );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_AUTOREFERER, true );
		curl_setopt( $ch, CURLOPT_MAXREDIRS, 10 );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, array('Content-Type: '.$content_type) );
		curl_setopt( $ch, CURLOPT_POST, true );
		curl_setopt( $ch, CURLOPT_POSTFIELDS, $postdata);
		$results=curl_exec($ch);
		curl_close($ch);
		if($results==false){
			// error_log('Unable to scan file: '.$postdata['file']->name.' with result: '.$result);
		}else{
			$result = json_decode($results, true);
			if(isset($result['status'])){
				if ($result['status'] == 'success') {
					if($result['result']!='OK')
						$response = $result['result'];
				}else if($result['status']=='error'){
					error_log("Exception on server");
				}
			}else if(strpos($results, 'Summary')){
				
			}else{
				error_log("Any other issues on server");
			}
		}
		return $response;
	}

	function check_with_repo_files($file_content, $repo_file_path){
		$issues = array();
		if(file_exists($repo_file_path)){
	        $content=@file_get_contents($repo_file_path);
            $hash_repo = md5($content);
            $hash_file = md5($file_content);
            if ($hash_file != $hash_repo) {
            	$flag=1;
                $issues=array("exist" => "Mismatch in Files");
            }
	    } else {
	    	$issues=array('exist'=>'Unwanted File Found');
	    }
        return $issues;
	}

	function getlines($contents, $href){
		$newissues = 0;
		$lines = preg_split("/((\r?\n)|(\r\n?))/", $contents);
		for($i=0; $i<count($lines); $i++){
			$line =  $lines[$i];
			if (strpos($line, $href) !== false) {
				$newissues = $i+1;
			}
		}
		return $newissues;
	}

	function check_external_link($contents){
		$issues = array();
		$hrefs = preg_match_all('/<a\s+(?:[^"\'>]+|"[^"]*"|\'[^\']*\')*href=("[^"]+"|\'[^\'‌​]+\'|[^<>\s]+)/i', $contents, $matches) ? $matches: array();
		if(isset($hrefs[1])){
			foreach($hrefs[1] as $href){
				if($this->isexternal($href)){
					$line=$this->getlines($contents, $href);
					$issues[] = array("i"=>"eld", "d"=>$href, "l"=>$line);
				}
			}
		}
		return $issues;
	}

	function isexternal($url) {
	  $url = trim($url);
	  $url = trim($url,';');
	  $url = trim($url,'(');
	  $url = trim($url,')');
	  $url = trim($url,"'");
	  $url = trim($url,'"');
	  $components = parse_url($url); 
	  if(isset($components['host'])){
	  	if(preg_match('/(wordpress|google|miniorange|xecurify|facebook|themeisle|adobe|phppot)/i', $components['host']) === 1) {}
	  	else{
			if(!empty($components['host']) && strpos(strtolower($components['host']),strtolower($_SERVER['HTTP_HOST'])) === false){
				return true;
			}
		}
	  }
	  return false;
	}	

	function getFunctionArgumentsOrEnclosedString($issueFunction, $tokens, $start, $issuetype, $checkForExternalLink){
		
		$flag = 1;
		$argument = "";
		$line = "";
		$issue = array();
		for($j=$start; $j< sizeof($tokens); $j++) {
			$innertoken = $tokens[$j];
			if ($flag==1 && is_array($innertoken)) {
				$argument .= $innertoken[1];
				if(empty($line))
					$line = $innertoken[2];
			} else if($innertoken==";"){
				$argument .= ";";
				if($checkForExternalLink){
					if($this->isexternal($argument)){
						$issue = array("l"=>$line, "t"=> $issueFunction, "i"=>$issuetype, "d"=>$argument);
					}
				} else {
					$issue = array("l"=>$line, "t"=> $issueFunction, "i"=>$issuetype, "d"=>$argument);
				}
				break;
			} else if($flag==1){
				$argument .= $innertoken;
			}
		}
		return $issue;
	}

	function remove_dir($repo_path){
		$dir=$repo_path;
		$it = new RecursiveDirectoryIterator($dir, RecursiveDirectoryIterator::SKIP_DOTS);
		$files = new RecursiveIteratorIterator($it,RecursiveIteratorIterator::CHILD_FIRST);
		foreach($files as $file) {
		    if ($file->isDir()){
		        rmdir($file->getRealPath());
		    } else {
		        unlink($file->getRealPath());
		    }
		}
		rmdir($dir);
	}

	function count_total_files($folder_paths, $base, $scan_config){
		$mo2f_malware_db_handler = new MoWpnsDB();
		$file_count=0;
		$nooffiles=0;
		$file_path_array=array();
		$skip_path_array= array();
		$folder_skip_array=array();
		$extensions = array();
		if($scan_config['type_scan'] == "Custom Scan"){
			$file_ext = $scan_config['file_extension'];
			if(empty($file_ext)){

			}else{
				if(strpos($file_ext,';') !=false){
					$extensions = explode(";", $file_ext);
				}else{
					array_push($extensions, $file_ext);
				}
			}
			$folder_skip_array= empty($scan_config['path_skip']) ? array() : explode(";", $scan_config['path_skip']);

			for($i=0; $i<count($folder_skip_array); $i++){
				$pathParts = explode('/', $folder_skip_array[$i]);
				$n= sizeof($pathParts)-1;
				$folder= $pathParts[$n];
				array_push($skip_path_array, $folder);
			}
		}
		foreach ($folder_paths as $value) {
			$file_list= list_files($value,100);
			foreach ($file_list as $key => $value1) {
				//$value1 = str_replace('/', '\\', $value1);
				$source_file_path= $value1;
				if(is_dir($source_file_path)){
					continue;
				}
				$arr= explode(DIRECTORY_SEPARATOR, $source_file_path);
				if ($value == $base && ($scan_config['core_scan'] == 1)){
					// $arr = explode(DIRECTORY_SEPARATOR, $iterator->getSubPathName());
					if(($arr[count($arr)-1]== 'index.php' && (count($arr)==1 || in_array($arr[count($arr)-2], array('wp-content', 'plugins', 'themes'))) && !in_array('miniorangescan', $arr)) || (!in_array('plugins', $arr) && !in_array('themes', $arr) && !in_array('miniorangescan', $arr))){
								
					}else{
						continue;
					}
				}elseif ($value == $base.DIRECTORY_SEPARATOR.'wp-content'.DIRECTORY_SEPARATOR.'plugins' && $arr[count($arr)-1]=='index.php'){
					continue;
				}elseif ($value == $base.DIRECTORY_SEPARATOR.'wp-content'.DIRECTORY_SEPARATOR.'themes' &&  $arr[count($arr)-1]=='index.php'){
					continue;
				}
				$ext = pathinfo($source_file_path, PATHINFO_EXTENSION);
				if($scan_config['type_scan'] == "Custom Scan"){
					$flag_skip=0;
					if (!empty($folder_skip_array)) {
						for($q=0; $q<count($skip_path_array); $q++){
							if(strpos($source_file_path, $skip_path_array[$q])){
								$flag_skip=1;
								break;
							}
						}
					}
					if($flag_skip == 1){
						continue;
					}
					
					if(!empty($extensions)){
						if(!in_array($ext, $extensions)){
							continue;
						}
					}
				}
				if(in_array($ext, array('zip', 'log', 'htaccess','sitx','7z','rar','gz','tar.gz','jpg','jpeg','png','gif','svg','tiff','raw'))){
					continue;
				}
				$file_count++;
				$nooffiles=$nooffiles+1;
				$file_path_array[$nooffiles]= $source_file_path;
				if($nooffiles>0 && $nooffiles%100==0){
					$mo2f_malware_db_handler->insert_files_in_parts($file_path_array);
					$nooffiles=0;
					$file_path_array=array();
				}
			}
			$mo2f_malware_db_handler->insert_files_in_parts($file_path_array);
			$nooffiles=0;
			$file_path_array=array();
			update_option('mo_wpns_total_files', $file_count);
		}
	}

	function get_scan_result_parts($mo2f_malware_db_handler=null, $folderpaths=array(), $scan_config, $start_time, $time_limit){
		if(!empty($folderpaths)){
			if ( in_array( 'curl', get_loaded_extensions() ) ) {
				$scanresults=array();
				$nooffiles=0;//get_option('mo_wpns_files_scanned');
				$previous_scanned=get_option('mo_wpns_files_scanned');
				$scan_malware_count = 0;
				$repo_issue_count = 0;
				$malicious_link_count = 0;
				$file_ext = $scan_config['file_extension'];
				$host = 'http://scanner.api.xecurify.com/malwareservice/rest/file/upload';//constants
				$extensions = array();
				$hostname = 'scanner.api.xecurify.com';// put in constants file
				$malware_server_status = $this->mo_wpns_check_malware_server_status($hostname);
				if(empty($file_ext)){
				}else{
					if(strpos($file_ext,';') !=false){
						$extensions = explode(";", $file_ext);
					}else{
						array_push($extensions, $file_ext);
					}
				}
				$folder_skip_array= empty($scan_config['path_skip']) ? array() : explode(";", $scan_config['path_skip']);
				$skip_path_array= array();
				for($i=0; $i<count($folder_skip_array); $i++){
					$pathParts = explode('/', rtrim(str_replace('\\', '/', $folder_skip_array[$i])));
					$n= sizeof($pathParts)-1;
					$folder= $pathParts[$n];
					array_push($skip_path_array, $folder);
				}
				$enable_extns = $scan_config['type_scan'] == "Custom Scan" && !empty($file_ext) ? false : true;

				foreach ($folderpaths as $value) {
					$status=$this->check_exec_limit($start_time, $time_limit);//check limit for each file.
					if(!$status){//wp_remote_get
						update_option('mo_wpns_files_scanned', ((0.7*$nooffiles)+$previous_scanned));
						return array('file_count'=> $nooffiles, 'malware_count'=>$scan_malware_count, 'repo_issues'=>$repo_issue_count, 'malicious_link'=>$malicious_link_count, 'scan'=>$scanresults); 
						//time limit close by. Returned status of current scan. Update DB and make next request.
					}

					$scanresult=array();
					$source_file_path=$value->path;
					$ext = pathinfo($source_file_path, PATHINFO_EXTENSION);
					$ext= strtolower($ext);
					$extns = $enable_extns ? true : (in_array($ext, $extensions) ? true : false);
					if($extns){
						$nooffiles++;
						if((0.7*$nooffiles) > 50){//remove get_option
							update_option('mo_wpns_files_scanned', ((0.7*$nooffiles)+$previous_scanned));
						}
					}

                    $hash_of_file= md5_file($source_file_path);
                    $res=$mo2f_malware_db_handler->check_hash($hash_of_file);
					
                    $datascan = empty($res)?true:(isset($res[0]->scan_data) ? unserialize($res[0]->scan_data):false);
                    $scanmalware = is_array($datascan)?$datascan['malware']==0:(!empty($datascan) ? $datascan: true);
                    $malware_status = $scanmalware? 0 : 1;

                    if(!empty($res) && !$scanmalware ){}
                    	
                    else{
                    	$flag_update=0;
                    	$file_content=file_get_contents($source_file_path);
						
                    	$source_file_path_size = str_replace("\\", "/", $source_file_path);
                    	if(($scan_config['check_vulnerable'] == 1 || $scan_config['check_sql'] == 1) && !in_array($ext, array('zip','sitx','7z','rar','gz','tar.gz','jpg','jpeg','png','gif','svg','tiff','raw')) && filesize($source_file_path_size) < 1048576 && $malware_server_status && $extns && $scanmalware){
                    		$malware_status = 1;
                    		$cfile=curl_file_create($source_file_path, 'test/plain', time().basename($source_file_path));
                    		$postdata = array('file' => $cfile);
																
                    		$content_type = 'multipart/form-data';
                    		$issues = $this->mo_wpns_malware_scan_request($postdata, $host, $content_type);
                    		//$issues='';
                    		if ($issues) {
                    			$scan_malware_count++;
                    			$scanresult['scan'] = $issues;
                    			$flag_update=1;
                    		}
                        }else{

                        }

						if($flag_update == 0){
							$malware_status = ($scan_config['check_vulnerable'] || $scan_config['check_sql']) && $malware_status ? 1 : 0;
							$repo_status=0;
							$link_status=0;
							$scan_data = array('malware'=>$malware_status, 'repo'=>$repo_status, 'ext_link'=>$link_status);
							if(empty($res)){
								$mo2f_malware_db_handler->insert_hash($source_file_path, $hash_of_file, $scan_data);
							}else{
								$mo2f_malware_db_handler->update_hash($source_file_path, $hash_of_file, $scan_data);
							}
						}else{
							$infected_files=get_option('mo_wpns_infected_files');
							$infected_files++;
							update_option('mo_wpns_infected_files', $infected_files);
						}
                    }
					if(!empty($scanresult))
						$scanresults[$source_file_path]=$scanresult;

				}
				
				update_option('mo_wpns_files_scanned', ((0.7*$nooffiles)+$previous_scanned));
				return array('file_count'=> $nooffiles, 'malware_count'=>$scan_malware_count, 'repo_issues'=>$repo_issue_count, 'malicious_link'=>$malicious_link_count, 'scan'=>$scanresults);
			}else{
				return array('message'=>'CURL not installed on the server.');
			}
		} else {
			return array('message'=>'No folder selected for scanning.');
		}
	}

	function scan_for_ext_link($files_to_scan, $scan_config, $start_time, $time_limit, $reportid){
		error_log("checking 100 files for ext link");
		$mo2f_malware_db_handler = new MoWpnsDB();
		$scanresults=array();
		$previous_scanned=get_option('mo_wpns_files_scanned');
		$nooffiles=0;
		$malicious_link_count=0;
		// $repo_issue_count=0;
		foreach ($files_to_scan as $value) {
			$status=$this->check_exec_limit($start_time, $time_limit);//check limit for each file.
			if(!$status){//wp_remote_get
				update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
				return array('file_count'=> $nooffiles, 'malicious_link'=>$malicious_link_count, 'scan'=>$scanresults); 
				//time limit close by. Returned status of current scan. Update DB and make next request.
			}
			$flag_update=0;
			$nooffiles++;
			if((0.15*$nooffiles)> 50){// remove get_option
				update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
			}
			$source_file_path=$value->path;
			$hash_of_file= md5_file($source_file_path);
		    $res=$mo2f_malware_db_handler->check_hash($hash_of_file);
		    $datascan = empty($res)?true:(isset($res[0]->scan_data) ? unserialize($res[0]->scan_data):false);
		    //$repocheck = is_array($datascan)?$datascan['repo']==0:(!empty($datascan) ? $datascan: true);
		    $extlink = is_array($datascan)?$datascan['ext_link']==0:(!empty($datascan) ? $datascan: true);
		    //$repo_status = $repocheck? 0 : 1;
			$link_status = $extlink? 0 : 1;
			if(is_array($datascan)){
				$malware_status= $datascan['malware'];
			}else{
				$malware_status=0;
			}

			$scanresult=array();
			
			$file_content=file_get_contents($source_file_path);
			if($scan_config['ext_link_check'] == 1 && $extlink){
				$link_status=1;
				$elresult= $this->check_external_link($file_content);
				if(!empty($elresult)){
					$malicious_link_count++;
					$flag_update=1;
					$scanresult['extl']=$elresult;
				}
			}

			//repo check code to be added
			if($flag_update == 0){
				//$repo_status = $scan_config['check_repo'] && $repo_status ? 1 : 0;
				$link_status = $scan_config['ext_link_check'] && $link_status ? 1: 0;
				$repo_status=0;

				$scan_data = array('malware'=>$malware_status, 'repo'=>$repo_status, 'ext_link'=>$link_status);
				$infected_array=$mo2f_malware_db_handler->get_detail_report_with_id($reportid);
				$file_already_infected=false;
				foreach ($infected_array as $key => $value) {
					if($value->filename == $source_file_path){
						$file_already_infected=true;
						break;
					}
				}

				if($file_already_infected){

				}elseif(empty($res)){
					$mo2f_malware_db_handler->insert_hash($source_file_path, $hash_of_file, $scan_data);
				}else{
					$mo2f_malware_db_handler->update_hash($source_file_path, $hash_of_file, $scan_data);
				}
			}else{
				$infected_files=get_option('mo_wpns_infected_files');
				$infected_files++;
				update_option('mo_wpns_infected_files', $infected_files);
			}
			if(!empty($scanresult))
				$scanresults[$source_file_path]=$scanresult;
		}
		update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
		return array('file_count'=> $nooffiles, 'malicious_link'=>$malicious_link_count, 'scan'=>$scanresults);
	}

	function scan_with_repo($files_to_scan, $scan_config, $start_time, $time_limit, $reportid, $repo_file_path){
		error_log("checking 100 files with repo");
		$mo2f_malware_db_handler = new MoWpnsDB();
		$scanresults=array();
		$previous_scanned=get_option('mo_wpns_files_scanned');
		$nooffiles=0;
		$repo_issue_count=0;
		foreach ($files_to_scan as $value) {
			$status=$this->check_exec_limit($start_time, $time_limit);//check limit for each file.
			if(!$status){//wp_remote_get
				update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
				return array('file_count'=> $nooffiles, 'repo_issues'=>$repo_issue_count, 'scan'=>$scanresults); 
				//time limit close by. Returned status of current scan. Update DB and make next request.
			}
			$flag_update=0;
			$nooffiles++;
			if((0.15*$nooffiles) > 50){
				update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
			}
			$source_file_path=$value->path;
			$hash_of_file= md5_file($source_file_path);
		    $res=$mo2f_malware_db_handler->check_hash($hash_of_file);
		    $datascan = empty($res)?true:(isset($res[0]->scan_data) ? unserialize($res[0]->scan_data):false);
		    $repocheck = is_array($datascan)?$datascan['repo']==0:(!empty($datascan) ? $datascan: true);
		    $repo_status = $repocheck? 0 : 1;
		    if(is_array($datascan)){
		    	$malware_status = $datascan['malware'];
		    	$link_status = $datascan['ext_link'];
		    }else{
		    	$malware_status=0;
		    	$link_status=0;
		    }
			$scanresult=array();

			if($repocheck){
				$file_content=file_get_contents($source_file_path);
				$file_path_slash_correction = str_replace('/', '\\', $source_file_path);
				$source_file_path_array=explode("\\", $file_path_slash_correction);
				$repo_file_to_check=$repo_file_path;
				$path_flag=0;
				$path_key= array('plugins', 'themes', 'wp-admin', 'wp-includes');
				foreach ($path_key as $paths_key) {
					if(in_array($paths_key, $source_file_path_array)){
						$index= array_search($paths_key, $source_file_path_array);
						for($i=$index; $i<sizeof($source_file_path_array); $i++){
							$repo_file_to_check.=DIRECTORY_SEPARATOR.$source_file_path_array[$i];
						}
						$path_flag=1;
						break;
					}
				}
				if($path_flag == 0){
					$last_index=sizeof($source_file_path_array)-1;
					$repo_file_to_check.=DIRECTORY_SEPARATOR.$source_file_path_array[$last_index];
				}
				$repo_status=1;
				$issues = $this->check_with_repo_files($file_content, $repo_file_to_check);
	           	if(!empty($issues)){
	           		$repo_issue_count++;
	           		$scanresult['repo']=$issues;
	           		$flag_update=1;
	            }
	        }

            if($flag_update == 0){
				$repo_status = $scan_config['check_repo'] && $repo_status ? 1 : 0;
				//$link_status = $scan_config['ext_link_check'] && $link_status ? 1: 0;

				$scan_data = array('malware'=>$malware_status, 'repo'=>$repo_status, 'ext_link'=>$link_status);
				$infected_array=$mo2f_malware_db_handler->get_detail_report_with_id($reportid);
				$file_already_infected=false;
				foreach ($infected_array as $key => $value) {
					if($value->filename == $source_file_path){
						$file_already_infected=true;
						break;
					}
				}

				if($file_already_infected){

				}elseif(empty($res)){
					$mo2f_malware_db_handler->insert_hash($source_file_path, $hash_of_file, $scan_data);
				}else{
					$mo2f_malware_db_handler->update_hash($source_file_path, $hash_of_file, $scan_data);
				}
			}else{
				$infected_files=get_option('mo_wpns_infected_files');
				$infected_files++;
				if(!empty($res)){
					$mo2f_malware_db_handler->delete_hash($source_file_path);
				}
				update_option('mo_wpns_infected_files', $infected_files);
			}
			if(!empty($scanresult))
				$scanresults[$source_file_path]=$scanresult;
		}
		update_option('mo_wpns_files_scanned', ((0.15*$nooffiles)+$previous_scanned));
		return array('file_count'=> $nooffiles, 'repo_issues'=>$repo_issue_count, 'scan'=>$scanresults);
	}

	function check_exec_limit($start_time, $time_limit){
		if($time_limit == 0){
			return true;
		}else{
			$time_remaining= $time_limit - (time()-$start_time);
			if($time_remaining > 10){
				return true;
			}else{
				return false;
			}
		}
	}

}
new Mo_wpns_Scan_Handler_Cron;
?>