<?php
add_action('admin_footer','mo_wpns_start_scan');
?>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
	
	<div class="mo_wpns_dashboard_layout">
		<div class="malwaresummarydiv">
			<?php show_summary(); ?>		
		</div>
	</div>
		<div class="mo_wpns_setting_layout" id="scan_status_table">
			<div>
				<p class="hmdiv">Scan Modes</p>
			</div>
			<div style="float: left;">
				<p id="scanstatus"></p>
			</div>
			<div class="malwaresummarydiv">
				<div class="mo_wpns_sub_scanmode mo_wpns_msdivl">
					<div class="hdiv"><b>Quick Scan</b></div>
					<hr class="line">
					<p class="mo_wpns_scan_desc">Quick Scan checks all Plugins, Themes and Core files for Vulnerable Code and SQL Injections using PHP malware signatures.</p>
					<input type = "hidden" id = "wpns_quick_scan_nonce" value="<?php echo wp_create_nonce('wpns-quick-scan') ?>" >
					<input id="quick_scan_button" type="button" name="quick_scan_button" class="mo_wpns_scan_button" value="Quick Scan">
				</div>
				<div class="mo_wpns_sub_scanmode mo_wpns_msdivr mo_wpns_msdivl">
					<div class="hdiv"><b>Standard Scan</b></div>
					<hr class="line">
					<p class="mo_wpns_scan_desc">Standard Scan checks all Plugins, Themes and Core files for external links and compares with the repository as well.</p>
					<input type = "hidden" id = "wpns_standard_scan_nonce" value="<?php echo wp_create_nonce('wpns-standard-scan') ?>" >
					<input id="standard_scan_button" type="button" name="standard_scan_button" class="mo_wpns_scan_button" value="Standard Scan">
				</div>
				<div class="mo_wpns_sub_scanmode mo_wpns_msdivl mo_wpns_msdivr">
					<div class="hdiv">
						<b>Deep Scan</b>
						<strong><a href="admin.php?page=mo_2fa_upgrade"> <b style="color: red;">[Premium]</b> </a></strong>
					</div>
					<hr class="line">
					<p class="mo_wpns_scan_desc">Deep Scan checks all Plugins, Themes and Core files for RFI, Trojans and Backdoors using advanced signatures and detects blacklisted domains as well.</p>
					<input id="deep_scan_button" type="button" name="deep_scan_button" class="mo_wpns_deep_scan_button" value="Deep Scan">
				</div>
				<div class="mo_wpns_sub_scanmode mo_wpns_msdivr">
					<div class="hdiv"><b>Custom Scan</b></div>
					<hr class="line">
					<p class="mo_wpns_scan_desc">Custom Scan gives you an option to choose which files to scan and what to check for.</p>
					<input type = "hidden" id = "wpns_custom_scan_nonce" value="<?php echo wp_create_nonce('wpns-custom-scan') ?>" >
					<input id="custom_scan_button" type="button" name="custom_scan_button" class="mo_wpns_scan_button" value="Custom Scan">
					<input type="button" name="configure_button" class="mo_wpns_scan_button" value="Configure" style="float: right;" onclick="openTabmalware(event, 'settings_scan')" >
				</div>
			</div>
		</div>
	</div>
	<div class="mo_wpns_setting_layout" id="mo_progress" style="display: none;">
		<h3 id="progress_message">Scan progress...</h3>
		<div id="mo_wpns_progress" class="mo_wpns_progress">
			<div id="mo_wpns_progress_bar" class="mo_wpns_progress_bar">0%</div>
		</div>
        <div id="mo_stop_button_div" style="display: none;">
            <input type="button" name="mo_stop_button" id="mo_stop_button" class="mo_wpns_scan_button" value="Stop Scan" style="margin-left: 45%;">
        </div >
	</div>
	
<?php
function mo_wpns_start_scan(){
	if ( ('admin.php' != basename( $_SERVER['PHP_SELF'] )) || ($_GET['page'] != 'mo_2fa_malwarescan') ) {
        return;
    }
?>
<script>
	var progress_bar,scan_progress,stop_scan_progress;;
	jQuery(document).ready(function(){
		scan_progress= "<?php echo get_option('mo_wpns_malware_scan_in_progress'); ?>";
        stop_scan_progress= "<?php echo get_option('mo_stop_scan'); ?>";
		if(scan_progress=="IN PROGRESS"){
			status_progress();
			jQuery('input[name="quick_scan_button"]').attr('disabled', true);
			jQuery('input[name="custom_scan_button"]').attr('disabled', true);
			jQuery('input[name="standard_scan_button"]').attr('disabled', true);
			var mode_scan="<?php echo get_option('mo_wpns_scan_mode'); ?>";
			if(mode_scan=="quick_scan"){
				document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('custom_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('standard_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('quick_scan_button').value="Scanning..."
			}
			else if(mode_scan=="standard_scan"){
				document.getElementById('quick_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('custom_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('standard_scan_button').value="Scanning..."
			}
			else if(mode_scan=="custom_scan"){
				document.getElementById('quick_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('standard_scan_button').style.backgroundColor = '#b0d2cf';
				document.getElementById('custom_scan_button').value="Scanning..."
			}
			document.getElementById("mo_progress").style.display="block";
            document.getElementById('mo_stop_button_div').style.display="block";

            if(stop_scan_progress==1){

                jQuery('input[name="mo_stop_button"]').attr('disabled', true);
                jQuery('input[name="mo_stop_button"]').val("Stop Scanning...");
                document.getElementById('mo_stop_button').style.backgroundColor = '#b0d2cf';
            }
			progress_bar = setInterval(status_progress, 10000);
		}
	jQuery('input[name="quick_scan_button"]').click(function(){
		document.getElementById("quick_scan_button").value = "Scanning...";

		document.getElementById("mo_progress").style.display="block";
		document.getElementById("progress_message").innerHTML = "Scan progress...";
        jQuery('input[name="mo_stop_button"]').val("Stop Scan");
        document.getElementById('mo_stop_button_div').style.display="block";
		document.getElementById("mo_wpns_progress_bar").style.width= 0 + "%";
		document.getElementById("mo_wpns_progress_bar").innerHTML= 0 + "%";
		progress_bar= setInterval(status_progress, 10000);

		jQuery('input[name="quick_scan_button"]').attr('disabled', true);
		jQuery('input[name="custom_scan_button"]').attr('disabled', true);
		jQuery('input[name="standard_scan_button"]').attr('disabled', true);
		document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
		document.getElementById('custom_scan_button').style.backgroundColor = '#b0d2cf';
		document.getElementById('standard_scan_button').style.backgroundColor = '#b0d2cf';

		var data={
			'action':'mo_wpns_malware_redirect',
			'call_type':'malware_scan_initiate',
			'scan':'scan_start',
			'scantype':'quick_scan',
			'nonce':jQuery('#wpns_quick_scan_nonce').val()
		};
		jQuery.post(ajaxurl, data, function(response){
			jQuery('#mo_scan_message').show();
			jQuery('#mo_scan_message').empty();
            jQuery("#mo_scan_message").removeClass("notice-error notice-success");
			if(response == "scanning_already"){
				jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
				jQuery("#mo_scan_message").append("A scan is currently ongoing.");
				window.scrollTo({ top: 0, behavior: "smooth"});
				document.getElementById("quick_scan_button").value = "Quick Scan";
				document.getElementById('quick_scan_button').style.backgroundColor = '#b0d2cf';
			}else{
				if(response=="ERROR"){
					jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
					jQuery("#mo_scan_message").append("Nonce did not match.");
					window.scrollTo({ top: 0, behavior: "smooth"});
				}else{
					jQuery("#mo_scan_message").addClass("notice notice-success is-dismissible");
					jQuery("#mo_scan_message").append("Malware Scan has started. You can see the results in scan reports tab after it is completed.");
                   // document.getElementById('mo_stop_button_div').style.display="none";
					//window.scrollTo({ top: 0, behavior: "smooth" });
					// jQuery('#summary_all_scan_text').html(response['total_files']);
					// jQuery('#summary_current_scan_text').html(response['scan_files']);
					// jQuery('#summary_all_infect_text').html(response['total_mal']);
					// jQuery('#summary_current_infect_text').html(response['mal_files']);
				}

				// jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
				// document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
				// document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
				// document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa'; 
				// document.getElementById("quick_scan_button").value = "Quick Scan";
			}
			
			
		});
	});

	jQuery('input[name="standard_scan_button"]').click(function(){
		document.getElementById("standard_scan_button").value = "Scanning...";

		document.getElementById("mo_progress").style.display="block";
		document.getElementById("progress_message").innerHTML = "Scan progress...";
        jQuery('input[name="mo_stop_button"]').val("Stop Scan");
        document.getElementById('mo_stop_button_div').style.display="block";
		document.getElementById("mo_wpns_progress_bar").style.width= 0 + "%";
		document.getElementById("mo_wpns_progress_bar").innerHTML= 0 + "%";
		progress_bar= setInterval(status_progress, 10000);
		
		jQuery('input[name="quick_scan_button"]').attr('disabled', true);
		jQuery('input[name="custom_scan_button"]').attr('disabled', true);
		jQuery('input[name="standard_scan_button"]').attr('disabled', true);
		document.getElementById('quick_scan_button').style.backgroundColor = '#b0d2cf';
		document.getElementById('custom_scan_button').style.backgroundColor = '#b0d2cf';
		document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';

		var data={
			'action':'mo_wpns_malware_redirect',
			'call_type':'malware_scan_initiate',
			'scan':'scan_start',
			'scantype':'standard_scan',
			'nonce':jQuery('#wpns_standard_scan_nonce').val()
		};
		jQuery.post(ajaxurl, data, function(response){
			jQuery('#mo_scan_message').show();
			jQuery('#mo_scan_message').empty();
            jQuery("#mo_scan_message").removeClass("notice-error notice-success");
			if(response == "scanning_already"){
				jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
				jQuery("#mo_scan_message").append("A scan is currently ongoing.");
				window.scrollTo({ top: 0, behavior: "smooth"});
				document.getElementById("standard_scan_button").value = "Standard Scan";
				document.getElementById('standard_scan_button').style.backgroundColor = '#b0d2cf';
			}else{
				if(response=="ERROR"){
					jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
					jQuery("#mo_scan_message").append("Nonce did not match.");
					window.scrollTo({ top: 0, behavior: "smooth"});
				}else{
					jQuery("#mo_scan_message").addClass("notice notice-success is-dismissible");
					jQuery("#mo_scan_message").append("Malware scan has started. You can see the results in scan reports tab after it is completed.");
                    // document.getElementById('mo_stop_button_div').style.display="none";
					//window.scrollTo({ top: 0, behavior: "smooth" });
					// jQuery('#summary_all_scan_text').html(response['total_files']);
					// jQuery('#summary_current_scan_text').html(response['scan_files']);
					// jQuery('#summary_all_infect_text').html(response['total_mal']);
					// jQuery('#summary_current_infect_text').html(response['mal_files']);
				}

				// jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
				// document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
				// document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
				// document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
				// document.getElementById("standard_scan_button").value = "Standard Scan";
			}
			
		});
	});

	jQuery('input[name="custom_scan_button"]').click(function(){
		document.getElementById("custom_scan_button").value = "Scanning...";

		document.getElementById("mo_progress").style.display="block";
		document.getElementById("progress_message").innerHTML = "Scan progress...";
        jQuery('input[name="mo_stop_button"]').val("Stop Scan");
        document.getElementById('mo_stop_button_div').style.display="block";
		document.getElementById("mo_wpns_progress_bar").style.width= 0 + "%";
		document.getElementById("mo_wpns_progress_bar").innerHTML= 0 + "%";
		progress_bar= setInterval(status_progress, 10000);
		
		jQuery('input[name="quick_scan_button"]').attr('disabled', true);
		jQuery('input[name="custom_scan_button"]').attr('disabled', true);
		jQuery('input[name="standard_scan_button"]').attr('disabled', true);
		document.getElementById('quick_scan_button').style.backgroundColor = '#b0d2cf';
		document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
		document.getElementById('standard_scan_button').style.backgroundColor = '#b0d2cf';
		
		var data={
			'action':'mo_wpns_malware_redirect',
			'call_type':'malware_scan_initiate',
			'scan':'scan_start',
			'scantype':'custom_scan',
			'nonce':jQuery('#wpns_custom_scan_nonce').val()
		};
		jQuery.post(ajaxurl, data, function(response){
			jQuery('#mo_scan_message').show();
			jQuery('#mo_scan_message').empty();
            jQuery("#mo_scan_message").removeClass("notice-error notice-success");
			if(response == "scanning_already"){
				jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
				jQuery("#mo_scan_message").append("A scan is currently ongoing.");
				window.scrollTo({ top: 0, behavior: "smooth"});
				document.getElementById("custom_scan_button").value = "Custom Scan";
				document.getElementById('custom_scan_button').style.backgroundColor = '#b0d2cf';
			}else{
				if(response=="ERROR"){
					jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
					jQuery("#mo_scan_message").append("Nonce did not match.");
					window.scrollTo({ top: 0, behavior: "smooth"});
				}else{
					jQuery("#mo_scan_message").addClass("notice notice-success is-dismissible");
					jQuery("#mo_scan_message").append("Malware Scan has started. You can see the results in scan reports tab after it is completed.");
                    // document.getElementById('mo_stop_button_div').style.display="none";
					//window.scrollTo({ top: 0, behavior: "smooth" });
					// jQuery('#summary_all_scan_text').html(response['total_files']);
					// jQuery('#summary_current_scan_text').html(response['scan_files']);
					// jQuery('#summary_all_infect_text').html(response['total_mal']);
					// jQuery('#summary_current_infect_text').html(response['mal_files']);
				}

				// jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
				// document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
				// document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
				// jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
				// document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
				// document.getElementById("custom_scan_button").value = "Custom Scan";
			}
			
		});
	});	

	jQuery('input[name="mo_stop_button"]').click(function(){
		// jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
		// document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
		// document.getElementById("quick_scan_button").value = "Quick Scan";
		// jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
		// document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
		// document.getElementById("standard_scan_button").value = "Standard Scan";
		// jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
		// document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
		// document.getElementById("custom_scan_button").value = "Custom Scan";
        jQuery('input[name="mo_stop_button"]').attr('disabled', true);

        jQuery('input[name="mo_stop_button"]').val("Stop Scanning...");
        document.getElementById('mo_stop_button').style.backgroundColor = '#b0d2cf';
		// document.getElementById("mo_progress").style.display="none";
		var data={
			'action':'mo_wpns_malware_redirect',
			'call_type':'malware_scan_terminate'
		};
        jQuery("#mo_scan_message").removeClass("notice-error notice-success");
		jQuery.post(ajaxurl, data, function(response){
			jQuery('#mo_scan_message').show();
			jQuery('#mo_scan_message').empty();
			jQuery("#mo_scan_message").addClass("notice notice-success is-dismissible");
			jQuery("#mo_scan_message").append("Scan is stopping...");
			window.scrollTo({ top: 0, behavior: "smooth" });
		});
	});
});

	function status_progress(){
		var data={
			'action':'mo_wpns_malware_redirect',
			'call_type':'malware_progress_bar'
		};
		jQuery.post(ajaxurl, data, function(response){
            jQuery("#mo_scan_message").removeClass("notice-error notice-success");
			var bar= document.getElementById("mo_wpns_progress_bar");
			if(response['status']=="COMPLETE"){
				document.getElementById("progress_message").innerHTML = "Scan completed";
				bar.style.width= 100 + "%";
				bar.innerHTML = 100 + "%";

				// jQuery('#mo_stop_button').hide();
				jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
				document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('quick_scan_button').value="Quick Scan";
				jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
				document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('standard_scan_button').value="Standard Scan";
				jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
				document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
				document.getElementById('custom_scan_button').value="Custom Scan";
				jQuery('#summary_all_scan_text').html(response['total_files']);
				jQuery('#summary_current_scan_text').html(response['scan_files']);
				jQuery('#summary_all_infect_text').html(response['total_mal']);
				jQuery('#summary_current_infect_text').html(response['mal_files']);

				jQuery('#mo_scan_message').show();
				jQuery('#mo_scan_message').empty();
				jQuery("#mo_scan_message").addClass("notice notice-success is-dismissible");
				jQuery("#mo_scan_message").append("Malware Scan is complete. You can see the results in scan reports tab now.");
				window.scrollTo({ top: 0, behavior: "smooth" });

                jQuery('input[name="mo_stop_button"]').val("Stop Scan");
                document.getElementById('mo_stop_button_div').style.display="none";
                document.getElementById('mo_stop_button').style.backgroundColor = '#20b2aa';
                jQuery('input[name="mo_stop_button"]').removeAttr('disabled');
				clearInterval(progress_bar);
			}else if(response['status']=="ABORTED"){
                document.getElementById("progress_message").innerHTML = "Scan Aborted";
                bar.style.width= 100 + "%";
                bar.innerHTML = 100 + "%";

                // jQuery('#mo_stop_button').hide();
                jQuery('input[name="quick_scan_button"]').removeAttr('disabled');
                document.getElementById('quick_scan_button').style.backgroundColor = '#20b2aa';
                document.getElementById('quick_scan_button').value="Quick Scan";
                jQuery('input[name="standard_scan_button"]').removeAttr('disabled');
                document.getElementById('standard_scan_button').style.backgroundColor = '#20b2aa';
                document.getElementById('standard_scan_button').value="Standard Scan";
                jQuery('input[name="custom_scan_button"]').removeAttr('disabled');
                document.getElementById('custom_scan_button').style.backgroundColor = '#20b2aa';
                document.getElementById('custom_scan_button').value="Custom Scan";
                jQuery('#summary_all_scan_text').html(response['total_files']);
                jQuery('#summary_current_scan_text').html(response['scan_files']);
                jQuery('#summary_all_infect_text').html(response['total_mal']);
                jQuery('#summary_current_infect_text').html(response['mal_files']);

                jQuery('#mo_scan_message').show();
                jQuery('#mo_scan_message').empty();
                jQuery("#mo_scan_message").addClass("notice notice-error is-dismissible");
                jQuery("#mo_scan_message").append("Malware Scan is aborted. You can check the results.");
                window.scrollTo({ top: 0, behavior: "smooth" });
                jQuery('input[name="mo_stop_button"]').val("Stop Scan");
                document.getElementById('mo_stop_button_div').style.display="none";
                document.getElementById('mo_stop_button').style.backgroundColor = '#20b2aa';
                jQuery('input[name="mo_stop_button"]').removeAttr('disabled');
                clearInterval(progress_bar);
            }else{
				jQuery('#mo_scan_message').hide();
				jQuery('#mo_scan_message').empty();
				if(response['total'] === false || response['total'] == 0){
					var width = 0;
				}else{
					var width= (response['scanned']/response['total'])*100;
					width = Math.round(width);
				}
				bar.style.width= width + "%";
				if(response['repo_scan']==1 && width==85){
					document.getElementById("progress_message").innerHTML= "Downloading plugins/themes/wordpress files from repository...";
					bar.innerHTML = width + "%";
				}else{
					document.getElementById("progress_message").innerHTML= "Scan progress...";
					bar.innerHTML = width + "%";
				}
			}
		});
	}
</script>
<?php
}
function show_summary(){
	$mo_wpns_db_handler = new MoWpnsDB();
	$last_id=$mo_wpns_db_handler->get_last_id();
	$send_id=$last_id[0]->max;
	if(is_null($send_id)){
		$total_scan=0;
		$total_malicious=0;
		$last_scan=0;
		$malicious_last_scan=0;
	}else{
		$result = $mo_wpns_db_handler->get_report_with_id($send_id);
		$total_scan=$mo_wpns_db_handler->count_files();
		$total_malicious=$mo_wpns_db_handler->count_malicious_files();
		$last_scan=$mo_wpns_db_handler->count_files_last_scan($send_id);
		$malicious_last_scan=$mo_wpns_db_handler->count_malicious_last_scan($send_id);
		if($total_scan > 999){
			$total_scan=($total_scan/1000);
			$total_scan= round($total_scan,1)."k";
		}
		if($total_malicious > 999){
			$total_malicious=($total_malicious/1000);
			$total_malicious= round($total_malicious,1)."k";
		}
	}
?>
	<div class="mo_wpns_sub_scansummary mo_wpns_msdivl" id="summary_all_scan">
		<div class="hdiv"><b>Total Files Scanned</b></div>
		<hr class="line">
		<p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_all_scan_text"> <?php echo $total_scan ?> </p>
	</div>
	<div class="mo_wpns_sub_scansummary mo_wpns_msdivr mo_wpns_msdivl" id="summary_all_infect">
		<div class="hdiv"><b>Total Infected Files</b></div>
		<hr class="line">
		<p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_all_infect_text"> <?php echo $total_malicious ?> </p>
	</div>
	<div class="mo_wpns_sub_scansummary mo_wpns_msdivl mo_wpns_msdivr" id="summary_current_scan">
		<div class="hdiv"><b>Files scanned in last scan</b></div>
		<hr class="line">
		<p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_current_scan_text"> <?php echo $last_scan ?> </p>
	</div>
	<div class="mo_wpns_sub_scansummary mo_wpns_msdivr" id="summary_current_infect">
		<div class="hdiv"><b>Infected Files in last scan</b></div>
		<hr class="line">
		<p class="wpns_font_size mo_wpns_scan_summary_text" id="summary_current_infect_text"> <?php echo $malicious_last_scan ?> </p>
	</div>	
	
<?php
}

